require 'browser'

class Browser

  def self.make_command(name, start_action, fields, finish_action)
    command = "def #{name}(#{fields.join(', ')});"
    command << "press(#{start_action.inspect});" if start_action

    fields.each { | field |
      command << "enter(#{field.inspect}, #{field});"
    }
    command << "press(#{finish_action.inspect}); end"
    module_eval(command)
  end

  make_command(:login, nil, [:login, :password], :login)
  make_command(:new_case, :want_new_case_form,
               [:client, :clinic_id], :record_case)
  make_command(:new_visit, :want_add_visit_form,
               [:diagnosis, :charges, :comments], :record_visit)
  make_command(:new_audit, :want_add_audit_form,
               [:auditor, :variance], :record_audit)
end
