require 'uri'
require 'net/http'
require 'rexml/document'
require 'cgi'
require 'date'
require 'test-util'


class Browser

  attr_reader :current_page

  def initialize
    @field_values = {}
    @current_page = ''
  end

  def reset; initialize; end

  def log(text='')
    puts text unless ENV['quiet']=='true'
  end

  def refresh
    get_page('/refresh')
  end

  def get_page(action)
    response = @http.get(action)
    @current_page = response.body
  end

  def go(url)
    uri = URI.parse(url)
    host, port, servlet = uri.host, uri.port, uri.path
    log "go to <#{url}>"
    @http = Net::HTTP.start(host, port)
    get_page(servlet)
  end

  def enter(field, value)
    log "Enter #{value.inspect} into field #{field.inspect}"
    @field_values[field] = value
  end

  def press(button)
    button = update_action_name(button)
    log "Press #{button.inspect}"
    log
    parameters = @field_values.collect { | key, value |
      "#{CGI.escape(key.to_s)}=#{CGI.escape(value.to_s)}"
    }.join("&")
    get_page("/#{button}?#{parameters}")
    @field_values = {}
  end


end
